# Changelog paw-HERMES

## liens utiles

  - [swagger du projet](/api/swagger/index.html)
  - [documentation du projet](/api/dmo/doc)

### Liste des hosts accessibles pour la solution :

intitulé|host par vpn|host externe
--------|------------|------------
environnement de développement|[https//dev.hermes.openstack.local](https://dev.hermes.openstack.local)|[https://doc-alshermes-int.be-idys.com](https://doc-alshermes-int.be-idys.com)
environnement de recette|[https://test.hermes.openstack.local](https://test.hermes.openstack.local)|[https://als-hermes-scoring-rec.be-idys.com](https://als-hermes-scoring-rec.be-idys.com)
environnement de démo|[https://demo.hermes.openstack.local](https://demo.hermes.openstack.local)|[https://als-hermes-demo.be-idys.com](https://als-hermes-demo.be-idys.com)


## url GED

[https://ged-test.dev.hermes.openstack.local](https://ged-test.dev.hermes.openstack.local)

## Notice d'utilisation

### Format des intitulés de version:

ex:

  0|.|34|.|12|-|26/03/2064
  -|-|--|-|--|-|----------
  numéro d'itération de la solution||numéro du patch majeur||numéro du patch mineur||date d'ajout à la branche de développement

  donc : beta 34, patch 12, produit le 26 mars 2064

Les dates afichées représentent donc l'intégration de la version à notre branche de développement.
Ces date ne correspondent donc pas à la date de mise en production sur l'environnement à partir duquel vous consultez ce changelog.

## 0.14.48 - 30/06/20
- Ajout endpoint `/entity_codes/check_entity_code_validity` pour vérifier l'existence et la validité d'un code.

## 0.14.47 - 12/06/20
- Mise à jour automatique de `housing_request.entity_status` en fonction de `entity.auto_request_validation`

## 0.14.46 - 08/06/20
- Modification de la valeur par défaut du champ `:auto_validation` de `true` vers `false` dans le modèle `Hermes::Entity`
- Ajout d'un champ `:auto_request_validation` dans le modèle `Hermes::Entity`
- Mise à jour de la doc et swagger pour la validation automatique des demandes
- Ajout du pannel administrateur pour le modèle `Hermes::UntensedArea`
- Modification des routes admin pour le modèle `Hermess::Threshold`

## 0.14.45 - 11/05/20
- Ajout endpoint `/applicants/:id/switch` pour se connecter "en tant que".

## 0.14.44 - 27/04/20
- Ajout endpoint `/statuses/applications_history` pour afficher tous les statuts d'application pour un candidat.
- Ajout des modèles `HousingRequestEntityForm` et `HousingRequestEntityFormLevel` pour la définition des niveaux de constement par candidat et entreprise
- Ajout des requêtes CRUD inhérentes aux modèles ci-dessus.

## 0.14.43 - 23/04/20
- [ajout des validations de matricule](/api/dmo/doc#h2-59)
- ajout d'un champ `:auto_validation` avec valeur par défaut à `true` dans le modèle `Hermes::Entity`
- ajout superadministrateur
- patch sur les pieces justificatives pour les rendre conformes a la 1.5
- ajout modèle/controller `Hermes::EntityCode` pour gérer les codes de rattachement d'un applicant à une entity.
- ajout de l'action `validate_code` sur le `HousingRequest` controller.

## 0.14.42 - 06/04/20
- ajout des untensed_areas
- Requalification d'offre (bailleur)

## 0.14.41 - 02/04/20
- **Modification du centre de notification**
- Changement mineur sur l'api notifications
- Changement majeur sur l'api subscriptions
- Mise à jour de la [doc](/api/dmo/doc#h2-48)
- Mise à jour swagger Hermes **API_DMO_NOTIFICATIONS** **API_DMO_SUBSCRIPTIONS**
- Ajout des modèles `HousingChannel` et `HousingChannelSetting` (gestion des filières logement)
- Ajout des endpoints `/add_housing_channel` et `/validate_housing_channel` dans le controller de `HousingRequest`
- Logique de mise à jour des clés "filières logement" (`housing_channel_pending_keys` et `housing_channel_keys`) pour une `HousingRequest`

## 0.14.40 - 24/03/20
- Ajout du modèle `HousingOfferExpirationSetting` + CRUD pour admin only.
- Ajout du callback de dépublication d'une offre + background job lorsque la date de fin de dépublication ou le seuil de candidatures est atteint.

## 0.14.39 - 20/03/20
- blocage des update sur les objets applicants, housing_requests, et required_documents lorsqu'il y a une candidature en cours (les objets restent éditables par les utilisateurs avec des roles administrators)

## 0.14.38 - 16/03/20
- Renommage du champs `city` pour `district` pour tout les modèle géolocalisable
- Ajout du bailleur en tant que reader sur HousingRequest, main_applicant et tout les coapplicants lié à l'offre du bailleur
- Retour de l'objet main_applicant en plus de housing_request sur la fiche d'une offre
- Retour de toute les demandes disponibles liées au bailleur si le current_user a le role `'bailleur'`
- Ajout d'une liste de champs interdits pour les bailleurs sur create/update de HousingOffer
- Possibilité de lier ou dé-lier un utilisateur à un `Lessor` (voir swagger `'API_DMO_LESSORS'` et **doc#h2-34**)
- Ajout action `score_position` sur housing_offers controller

## 0.14.37 - 10/03/20
- Ajout du champ `:visit_status` sur le modèle Hermes::HousingApplication
- Déclenchement du recalcul de score si annulation d'un applicant après une visite
- Ajout d'un compteur de candidature annulée sur le modèle Hermes::Applicant
- Malus de 35 points si le candidat se désiste après une visite
- Mise à jour du flux 40 de la documentation
- Mise à jour du swagger Edit et Create de HousingApplication
- Validation sur les deux types de status du modèle HousingApplication

## 0.14.36 - 09/03/20
- ajout logs de création/édition sur `HousingOffer` et `HousingRequest` avec le `current_user_id`
- Ajout du centre de notifications
- Configuration du modèle Hermes::Applicant comme target
- Configuration du modèle Hermes::Lessor comme target
- Configuration du modèle Hermes::HousingOffer comme Notifiable
- Configuration du modèle Hermes::HousingRequest comme Notifiable
- Création des routes pour la gestion des abonnements et notifications
- Notification des co-applicants lors d'un changement de status sur HousingRequest
- Notification des co-applicants lorsqu'un nouveau logement est disponible
- Documentation technique + Swagger + Collection Postman
- Ajout tri aggregation sur `HousingOffer` par codes postaux

## 0.14.35 - 06/03/20
- suppression du champ `:coordinates` pour les modèles Geolocalisable

## 0.14.34 - 05/03/20
- ajout d'un champs last_update_by_lessor et auto_destroy_next_day  sur housing_offer mis a jour a chaque modif (en prevision du destroy auto)
- le create d'une housing offer dont le lessor_id et le external_ref existe déja est transformé en update
- le lessor_status d'une housing_offer passe a DELETED lorsque auto_destroy_next_day est a true et que le last_update_by_lessor date de plus de 36h

## 0.14.33 - 04/03/20
- connexion à la ged (création/edit/et suppression des fichiers pieces justificatives dans la ged)
- ajout d'un nud_status pour les housing_request_folder
- ajout d'un is_required_for_nud pour les required_documents
- ajout du statut "Dossier complet prêt pour traitement" pour les 3 status du housing_request_folder
- ajout du statut "Prêt pour traitement" pour une piece justificative
- ajout d'une route pour lancer la kycsation du dossier.

## 0.14.32 - 26/02/20
- gestion des documents requis :  syncronisation sne des pieces (upload edit,upload create , delete, download initial)
- gestion des documents requis :  gestion des status (attention, remplacement du champs status du housing_request_folder -> voir doc)
- gestion des documents requis : réunion des pieces en un seul pdf
- gestion des documents requis :  gestion des droits sur les pieces
- ajout des champs `:longitude` et `:latitude` sur les modèles Geolocalizable


## 0.14.31 - 25/02/20
- ajout du modèle `DetailedScore` embedded in `Score`
- ajout de la route nestée '/detailed_score' sur `HousingOffersController` avec affichage conditionnel du score détaillé selon le user role
- tests des modèles et requêtes concernées

## 0.14.30 - 24/02/20
- ajout de min_effort_rate par défaut de 0.333
- ajout du champ `visit_conducted_date` au modèle `HousingApplication`

## 0.14.29 - 21/02/20
- ajout du modèle `LessorObjectiveHistory`
- ajout de la route nestée '/history' sur `HousingOffersController` avec affichage conditionnel des lessor_objective_histories selon le user role
- tests des modèles et requêtes concernées

## 0.14.28 - 17/02/20
- ajout du callback `generate_als_id` en `before_create` du modèle `HousingRequest`

## 0.14.27 - 14/02/20
- ajout du concern `Geolocalizable` sur les modèles `Entity` `HousingOffer` et `Applicant`
- suppression des champs `:latitude` et `:longitude` remplacés par `:coordinates` (`[:latitude, :longitude]`)
- test des modèles concernés

## 0.14.26 - 11/02/20
- prise en compte des nouvelles specs d'objectifs bailleurs
- Ajout du champ `insee_code` dans le modèle `HousingOffer`
- suppression des champs `seeked_districts`, `seeked_departments` et `seeked_district_postal_codes` des mutate params de `HousingRequest`, les champs étant persistés via le `seeked_localisation_list`
- mise à jour du swagger

## 0.14.25 - 06/02/20
- Ajout des reservataires
- possibilité de récuperer les departements SNE
- verification que les départements

## 0.14.24 - 03/02/20
- Ajout d'un utilitaire de recherche dans la documentation

## 0.14.23 - 03/02/20
- Passage des roles bailleur, demandeur et entreprise sur le champs auth_roles au lieu de roles et rle de demandeur par défault
- Récupération des infos de la demande suite à l'envoi du bon code pin recu par email (us 4155)

## 0.14.22 - 30/01/20
- Association code plafond de ressources

## 0.14.21 - 29/01/20
- Historisation des statuts sur : demandeur, entité, candidature, offre et demande et chaqu'un des statuts sur ces models

## 0.14.20 - 27/01/20
- us 2500 (tableau d'objectifs et condition d'incrémentation des objectifs)

## 0.14.19 - 27/01/20
- ajout d'une route pour récuperer toutes les operation_name des offres d'un bailleur
- test pour eviter que des lessors objectives soient dupliqués
- ajout filtre de recherche par siret sur les housing_requests
- mise a jour doc

## 0.14.18 - 22/01/20
- différenciation entre une offre is_public et published
## 0.14.17 - 20/01/20
- débug éligibilité familles 
- 5 nouveaux cas d’éligibilité
## 0.14.16 - 03/01/20
- débug du bug conduisant à la suppression des coapplicants
## Besoin de Core::Develop à la version du 18/12/19 (dernier commit : 63d22d502) :
- ajout de la capacité à mettre des index dans les query params `$or` et `$and`
## 0.14.15 - 19/12/19
- verification de tout les xml préalables à l'envoi
-
## 0.14.14 - 19/12/19
- maj du mapping pour le flux 30 à partir des remarques de la session de test précedente
- refonte du code pour l'US 2895 (la documentation et les points d'accès restent identiques)
## 0.14.13 - 18/12/19
- gestion du scope des documents requis (pour consultation/pour validation)
- ajout de la catégorie du document requis
- ajout des champs required_for_consultation/application , category, et is_for_main_applicant au json du required_document 
- ajout dans la doc de ces infos
## 0.14.12.1 17/12/19
- champs des contacts bailleur d'une offre (lessor_contact_name, lessor_email, lessor_phone_number) et son nom d'agence (agency_name) mutables.
## 0.14.12 - 17/12/19
- correction de l'affichage des groupes de supervision et de management des entités et des bailleurs
## 0.14.11 - 16/12/19
- Gestion des Nuds multiples au niveau du scoring (gestion par département)
## 0.14.10 - 13/12/19
- ajout de la gestion des droits lors de la modification d'un `lessor_siren` sur une offre
## 0.14.9 - 11/12/19
- ajout du point d'entrée permettant d'envoyer un code pin de sécurisation du nud.
- ajout d'un point d'entrée permettant à l'utilisateur de venir autentifier son nud avec le code pin reçu sur son email.
- ajout du champs "file_upload_from_sne_complete" sur les "housing_request_folder", booléen indiquant si la recherche sur le SNE à été réalisée ou non (non fonctionnel pour l'instant)
## Besoin de Core::Develop à la version du 11/12/19 (dernier commit : 70d7de8d1) :
- les recherches inclues les paramètres `$or` et `$and` et sont aussi récursifs
## 0.14.8 - 10/12/19
- hotfix : correction de l'action d'affichage des offres publiques
## 0.14.7 - 10/12/19
- ajout des champs `id`, `created_at` et `updated_at` au retour api des offres publiques.
## 0.14.6 - 10/12/19
- déclenchement du recalcule de l'éligibilité au changement du `offer_status`
## 0.14.5 - 10/12/19
- test du calcul de position avec capacité de monté en charge valide (testé et validé avec 20 000 données de score produites)
## 0.14.4 - 10/12/19
- tests à jour (inclut la première validation fonctionnelle du mapping d'une offre vers le format de la $bdd de SOPRA)
## 0.14.3 - 09/12/19
- prise en compte de toutes les regles de documents requis
## 0.14.2 - 06/12/19
- débuggage des flux sortants sopra
## 0.14.1 - 04/12/19
- L'upload de pièces justificatives passe par une requete PATCH au lieu de POST
- L'url de download des pièces est désormais renvoyée comme url absolue et non comme url relative
- Lancement du changelog en ligne
## 0.14 - 03/12/19
- Ajout de la fonctionnalité de gestion des pièces justificatives
- Ajout du moteur établissant la liste des pièces justificatives en fonction du dossier
- Ajout de la possibilité d'uploader des pièces justificatives
## 0.13.17 - 03/12/19
- affichage de la différence "attente - réalisé" sur les objectifs bailleur
- meilleur gestion de l'als_id + intégration de l'als_id sur les entity
## 0.13.15 - 03/12/19
- autres mises à jour mineurs et correction de la doc
## 0.13.11 à 0.13.14 - 02/12/19
- comptabilisation des  champs “created_at” et “updated_at” dans la recherche
- changement de correspondance du mapping d’envois SOPRA
- correction du bug des points entreprise
