
require 'csv'

def run_script
  offers = Hermes::HousingOffer.where(offer_status: { :$in => Hermes::HousingOffer::PUBLISHED_STATUSES })

  CSV.open('script_devops_8671.csv', "ab") do |csv|
    csv << ['housing_offer_id', 'housing_application_id', 'old_applicant_el_query', 'new_applicant_el_query']

    offers.batch_size(5).each do |offer|
      row = []
      unless offer.formated_eligibility.blank?  
        row.push(offer.id)
        applications = Hermes::HousingApplication.where(housing_offer_id: offer.id).actives
        applications.batch_size(5).each do |application|
          next unless application.housing_request

          applicant = application.housing_request.main_applicant
          row.push(application.id)
          row.push(applicant.eligibility_query)
          application.housing_request.update_applicant_eligbility
          row.push(applicant.reload.eligibility_query)
    
          eligibile_applicant_ids ||= Hermes::HousingRequest.where(is_active: true, **offer.formated_eligibility).pluck(:main_applicant_id)
    
          unless eligibile_applicant_ids.map(&:to_s).include?(application.housing_request.main_applicant_id.to_s)
            application.update(status: 'NON RETENUE')
            csv << row
          end
        end
      end
    end
  end
end

run_script